library Zelda_GBA;

uses
  ShareMem,
  Needs;

{$E .kpl}

resourcestring
 SKPLDescription = 'The Legend of Zelda: Minish Cap';

Var
 ROM: PBytes = NIL;
 RomSize: Integer = 0;
 EndsRoot: PTableItem = NIL;
 MaxCodes: Integer = 0;
 Align: Integer = 1;

Function Description: String; stdcall;
begin
 Result := SKPLDescription
end;

Function NeedEnd: Boolean; stdcall;
begin
 Result := False
end;

Function GetMethod: TMethod; stdcall;
begin
 Result := tmNone
end;

Procedure SetVariables(X: PBytes; Sz: Integer; ER: PTableItem; MC, AL: Integer); stdcall;
begin
 ROM := X;
 RomSize := Sz;
 EndsRoot := ER;
 MaxCodes := MC;
 Align := AL
end;

Function GetData(TextStrings: PTextStrings): AnsiString; stdcall;
var
 R: PTextString;
begin
 Result := '';
 If TextStrings = NIL then Exit;
 With TextStrings^ do
 begin
  R := Root;
  While R <> NIL do
  begin
   Result := Result + R^.Str + #0;
   R := R^.Next
  end
 end
end;

Function GetStrings(X, Sz: Integer): PTextStrings; stdcall;
var
 P: PByte; PC: PChar absolute P;
 Len: Integer; Code: Byte;
begin
 New(Result, Init);
 with Result.Add^ do
 begin
  P := Addr(ROM[X]);
  while P^ <> 0 do
  begin
  Len := 0;
   if (P^ = $01) or (P^ = $02) or (P^ = $03)
   or (P^ = $04) or (P^ = $05) or (P^ = $06)
   or (P^ = $07) or (P^ = $08) or (P^ = $09)
   or (P^ = $0C) or (P^ = $0F)
   then begin  //  1   
    Code := P^;
    Str := Str + PC^;
    Inc(P);
    case Code of
     $01,
     $02,
     $06,
     $08,
     $09,
     $0C,
     $0F: Len := 1;
     $03,
     $07: Len := 2;
     $04: case P^ of
             $10: Len := 2;
             else Len := 1
          end;
     $05: case P^ of
             $FF: Len := 1;
             else Len := 2
          end
    end;
    X := Length(Str);
    SetLength(Str, X + Len);
    Move(P^, Str[X + 1], Len);
    Inc(P, Len);
   end else
   begin
    Str := Str + PC^;
    Inc(P)
   end
  end
 end
end;

exports
 GetMethod,
 SetVariables,
 GetData,
 GetStrings,
 DisposeStrings,
 NeedEnd,
 Description;

end.

